#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include "ptwrapper_o.h"
#include "debug.h"

char *progname = "find";

/*D

  ptfind - SUT find

Description:

ptfind searches for files on multiple hosts

Command Line Arguments:

ptfind [-m <machine_file>|-M <machine_list>] [<find arguments>...]

.N machine_args
- [<find arguments>...] - the arguments to find(1)

Environment Variables:

.N machine_envs

Examples:

To find all the files in /homes/johndoe 
on the machines specified in the file "destination_machines" use

.vb
ptfind -m destination_machines /homes/johndoe
.ve

To do the same find, specifying the machines on the command line, use

.vb
ptfind -M "host1 host2 host3" /homes/johndoe
.ve

To concatenate the contents of the file "/etc/passwd" to the standard output
with the hostname preceeding each line printed, use

.vb
ptfind -m destination_machines /homes/johndoe
.ve

.seealso find(1)
  
 D*/
int check_args(int argc, char *argv[], char *cmd)
{
    int i;
    int len = 0;

    /* Always add the hostname */
    add_hostname = 1;

    /* Don't even try to check the validity of the arguments */
    cmd[0] = '\0';
    argv[0] = progname;
    for (i = 0; i < argc; i++) {
        len += strlen(argv[i]);
        if (len >= MAX_CMD_LEN)
            return -2;
        strcat(cmd, argv[i]);
        len += sizeof(" ");
        if (len >= MAX_CMD_LEN)
            return -2;
        strcat(cmd, " ");
    }

    pt_debug("the command is '%s'\n", cmd);

    return 0;
}
