%{
#include <string.h>
#include "nodes_y.h"

#ifdef FLEX_SCANNER
#	ifdef YY_INPUT
#		undef YY_INPUT
#	endif /* YYINPUT */
#	define YY_INPUT(b,r,ms)	((r) = buf_input((b), (ms)))
#endif /* FLEX_SCANNER */
/* FIXME: Need to add compatibility for standard lex */

#define MIN(x,y)	((x) < (y) ? (x) : (y))
#define YY_NO_UNPUT 1

extern char *input_buf_start, *input_buf_end;
static int buf_input(char *buf, int maxlen);
%}

%%

[0-9]+		{
				yylval.val = atoi(yytext);
				return INTEGER;
			}

[a-zA-Z][a-zA-Z0-9\.]*	{
				yylval.fmt = strdup(yytext);
				return NODE;
			}

[a-zA-Z]*%d[a-zA-Z0-9\.]*	{
				yylval.fmt = strdup(yytext);
				return FORMAT;
			}

[ \t\n]			;

[-@,]		{
				return *yytext;
			}
			
.			{
				fprintf(stderr, "Parse error at '%s'\n", yytext);
				return ERROR;
			}

%%

int yywrap()
{
	return 1;
}

static int buf_input(char *buf, int maxlen)
{
	int size = MIN(maxlen, input_buf_end - input_buf_start);

	if (size > 0){
		memcpy(buf, input_buf_start, size);
		input_buf_start += size;
	}

	return size;
}
