#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <time.h>

#define DFLT_SIZE		10000000
/*
usage: genrand [filesize] [filename]
 */

int main(int argc, char *argv[])
{
	int fd;
	int count = 0;
	int size = DFLT_SIZE;
	int incr;
	char *filename = "BIGFILE";
	
	if (argc > 1){
		if (sscanf(argv[1], "%d", &size) == 0){
			filename = argv[1];
		} else if (argc > 2){
			filename = argv[2];
		}
	}

	incr = (((size / 70) + (sizeof(int)-1))/sizeof(int)) * sizeof(int);

	fd = open(filename, O_WRONLY|O_CREAT, 0644);
	if (fd < 0){
		perror("genrand: Unable to open file\n");
		return 1;
	}

	srandom(time(NULL));

	printf("Generating the file '%s' of at least %d bytes...\n", 
		   filename, size);

	while (count < size){
		int r = random();
		if (write(fd, &r, sizeof(r)) != sizeof(r)){
			fprintf(stderr, 
					"genrand: warning - only able to write %d bytes\n", count);
			break;
		}
		count += sizeof(r);
		if (count % incr == 0){
			printf(".");
			fflush(stdout);
		}
	}

	close(fd);

	printf("done\n");
	return 0;
}
